// dependencies
const { parseURL } = require('ioredis/built/utils');
const { Queue, QueueEvents, QueueScheduler } = require('bullmq');

const redisConnection = parseURL('redis://localhost:6379/1');

const queue = new Queue('oom-test', { connection: redisConnection });
const queueEvents = new QueueEvents('oom-test', { connection: redisConnection });

const testJob = async (index) => {
  console.log(`Running testJob (${index})`);

  let job = await queue.add('all');
  const result = await job.waitUntilFinished(queueEvents);

  try {
    await job.remove();
    await queue.clean(0);
  } catch (e) {
    console.log(`Got error ${e}`);
  }

  return result;
};

const safeTestJob = async () => {
  try {
    await testJob();
  } catch (e) {
    console.log('Safe test job got err', e.message, e.stack);
  }
}

safeTestJob();

